package com.perforce.hive.api;

import java.io.IOException;
import java.util.List;

import com.perforce.hive.api.artifact.ArtifactInterface;
import com.perforce.hive.api.artifact.ArtifactType;
import com.perforce.hive.api.artifact.ResultInterface;
import com.perforce.hive.api.artifact.SummaryInterface;
import com.perforce.hive.api.repository.RepoInterface;
import com.perforce.hive.api.search.ResultDetailed;
import com.perforce.p4java.core.IDepot;
import com.perforce.p4java.core.file.IFileSpec;
import com.perforce.p4java.server.IOptionsServer;

import ro.fortsoft.pf4j.ExtensionPoint;
import spark.Request;
import spark.Response;

public interface Loader extends ExtensionPoint {

	public ArtifactType getType();

	public void loadImage(String endpoint) throws IOException;

	public ArtifactInterface getArtifact(Request request, Response response) throws Exception;

	public ArtifactInterface getProxy(IOptionsServer p4, String repoID) throws Exception;

	public SummaryInterface getSummary(IOptionsServer p4, List<IFileSpec> summary);

	public ResultInterface getResult(ResultDetailed result);

	public RepoInterface createRepository(ArtifactType type);

	public RepoInterface createRepository(Request request);

	public RepoInterface createRepository(IDepot depot);

	public Class<?> getRepositoryClass();
}
