package com.perforce.hive.connection;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.perforce.p4java.client.IClient;
import com.perforce.p4java.server.IOptionsServer;
import com.perforce.p4java.server.callback.ICommandCallback;

public class ConnectionLogging implements ICommandCallback {

	private static Logger logger = LoggerFactory.getLogger(ConnectionLogging.class);

	private final IOptionsServer p4;


	public ConnectionLogging(IOptionsServer p4) {
		this.p4 = p4;
	}

	@Override
	public void issuingServerCommand(int key, String commandString) {
		logger.info("[" + getUser() + "@" + getClient() + "] p4 " + commandString);
	}

	@Override
	public void completedServerCommand(int key, long millisecsTaken) {
		// TODO Auto-generated method stub

	}

	@Override
	public void receivedServerInfoLine(int key, String infoLine) {
		// TODO Auto-generated method stub

	}

	@Override
	public void receivedServerErrorLine(int key, String errorLine) {
		// TODO Auto-generated method stub

	}

	@Override
	public void receivedServerMessage(int key, int genericCode, int severityCode, String message) {
		logger.info("... p4 message: " + message);
	}
	
	private String getUser() {
		 String user = p4.getUserName();
		return user;
	}
	
	private String getClient() {
		String client = "UNSET";
		IClient iclient = p4.getCurrentClient();
		if (iclient != null) {
			client = iclient.getName();
		}
		return client;
	}

}
