package com.perforce.hive.view;

import java.util.List;

import javax.servlet.http.HttpServletResponse;

import org.apache.http.HttpResponse;

import com.perforce.hive.PluginArtifactFactory;
import com.perforce.hive.api.artifact.ArtifactInterface;
import com.perforce.hive.api.artifact.ArtifactType;
import com.perforce.hive.api.repository.RepoInterface;
import com.perforce.hive.common.AbstractControl;
import com.perforce.hive.connection.ConnectionSession;
import com.perforce.hive.depot.DepotFactory;
import com.perforce.hive.depot.DepotModel;
import com.perforce.p4java.server.IOptionsServer;

import spark.Request;
import spark.Response;

public class ViewControl extends AbstractControl {

	public static Object view(Request request, Response response) {

		// get raw file from Store or Proxy
		try {
			IOptionsServer p4 = ConnectionSession.get(request, response);
			String base = request.pathInfo();
			DepotModel depot = DepotFactory.getByBase(p4, base);
			RepoInterface repo = depot.getRepo();

			if (request.queryParams().isEmpty()) {
				HttpServletResponse raw = repo.fetch(p4, request, response);
				return raw;
			} else {
				HttpResponse raw = repo.query(p4, request, response);
				return raw;
			}

		} catch (Exception e) {
			e.printStackTrace();
			response.status(404);
			return response.raw();
		}
	}

	public static Object putDirect(Request request, Response response) {

		// direct upload of raw file to Store or Proxy
		try {
			// Upload file and Submit change
			ArtifactType type = PluginArtifactFactory.parseType("LOCAL");
			ArtifactInterface artifact = PluginArtifactFactory.getArtifact(type, request, response);
			List<String> upload = artifact.populateMonolithicPut(request);
			int pending = artifact.updatePending(upload);
			artifact.submitPending(pending, "Hive Direct Deploy");
			artifact.index();
			artifact.disconnect();
		} catch (Exception e) {
			e.printStackTrace();
			response.status(404);
			return response.raw();
		}
		return "";
	}

}
