$(function() {

	var depot = $("input[name=depotID]").val();
	var list = [];
	var index = 0;

	$.getJSON('/protect/' + depot, function(data) {
		list = data;
		$(data).each(function() {
			var group = this.group ? 'group' : 'user';
			addItem(group, this.mode, this.name, this.type);
		});
	});

	$("#plus").click(function() {
		addItem('user', 'write', '*', 'INCLUDE');
	});
	
	function addItem(group, mode, name, type) {
		index ++;
		
		var template = $("#template").clone();
		template.attr("id", index);
		
		if(mode === 'list' && type === 'EXCLUDE') {
			template.find('#acl-mode').text('hidden');
		} else {
			template.find('#acl-mode').text(mode);
		}
		
		template.find('#acl-group').text(group);
		template.find('#acl-user').val(name);
		
		template.on('click', '.dropdown-menu li a', function(){
			var drop = $(this).parents(".dropdown");
			var select = $(this).data('value');
			
			drop.find('code').text(select);
			drop.find('.btn').val(select);
		});
		
		template.on('click', '.trash', function() {
			var li = $(this).parents('li');
			li.remove();
		});

		$('.acl').append(template);
		$('.acl').sortable('refresh');
	}
	
	$('#createRepo').on('click', function() {
		var items = [];
		var index = 0;
		
		$("ul.acl").children().each(function() {
			var group = $(this).find('#acl-group').text();
			
			var acl = new Object();
			
			var mode = $(this).find('#acl-mode').text();
			if(mode === 'hidden') {
				acl.mode = 'list';
				acl.type = "EXCLUDE";
			} else {
				acl.mode = mode;
				acl.type = "INCLUDE";
			}
			
			acl.group = group === 'group';
			acl.host = "*";
			acl.name = $(this).find('#acl-user').val();
			acl.order = index;
			
			depot = $("input[name=depotID]").val();
			acl.left = '//' + depot + '/...';
			
			items.push(acl);
			index ++;
		});
		
		var jsonData = JSON.stringify(items);
		$("#acl_data").val(jsonData);
	});

});