package com.perforce.hive;

import static org.junit.Assert.assertEquals;

import java.io.File;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import com.google.gson.Gson;
import com.perforce.hive.connection.ConnectionConfig;
import com.perforce.hive.plugin.docker.model.DockerManifest1;

import spark.Spark;

public class DockerTest {

	@BeforeClass
	public static void beforeClass() {
		try {
			Spark.port(ConnectionConfig.get().getPort());
			Spark.staticFileLocation("/public");

			File pluginArchiveFile = new File("build/libs/DockerPlugin-0.1.0.zip");
			PluginArtifactFactory.loadPlugins(pluginArchiveFile);
			Main.start();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@AfterClass
	public static void afterClass() {
		Spark.stop();
	}

	@Test
	public void testGetManifest() {
		UnitResponse res = UnitSpark.request("GET", "/api/docker/repo/v2/name/manifests/reference");
		assertEquals(200, res.status);

		DockerManifest1 manifest = new Gson().fromJson(res.body, DockerManifest1.class);
		assertEquals(null, manifest.getName());
	}

}
